Index: Dev/branches/rest-dojo-ui/client/rft/store/CouchStore.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/store/CouchStore.js	(revision 410)
+++ Dev/branches/rest-dojo-ui/client/rft/store/CouchStore.js	(revision 410)
@@ -0,0 +1,262 @@
+define([
+    'dojo/_base/array',
+    'dojo/_base/declare',
+    'dojo/_base/Deferred',
+    'dojo/_base/json',
+    'dojo/_base/lang',
+    'dojo/_base/xhr',
+    'dojo/store/util/QueryResults'
+],function(array,declare,Deferred,json,lang,xhr,QueryResults){
+    
+    function getCouchError(err){
+        return (err.response && err.response.data)
+                ? json.fromJson(err.response.data)
+                : "Unknown error.";
+    }
+
+    var CouchStore = declare(null, {
+        /** dojo Store implementation for CouchDB
+         *
+         * See for details on the REST API, the wiki
+         * at http://wiki.apache.org/couchdb/HTTP_Document_API.
+         */
+        target: "",
+        accepts: "application/json", 
+        idProperty: "_id",
+        revProperty: "_rev",
+        _responseIdProperty: "id",
+        _responseRevProperty: "rev",
+        constructor: function(options){
+            declare.safeMixin(this, options);
+        },
+        getIdentity: function(object){
+            return object[this.idProperty];
+        },
+        getRevision: function(object){
+            return object[this.revProperty];
+        },
+        get: function(id){
+            var dfd = new Deferred();
+            xhr("GET", {
+                url: this.target + id,
+                handleAs: "json",
+                headers: {
+                    Accept: this.accepts
+                }
+            }).then(function(result){
+                if ( result.error ) {
+                    dfd.reject(result.reason);
+                } else {
+                    dfd.resolve(result);
+                }
+            }, function(err){
+                dfd.reject(getCouchError(err));
+            });
+            return dfd.promise;
+        },
+        put: function(object, options){
+             // summary:
+             //     put an object in CouchDB
+             // object: Object
+             //     The object to put
+             // options: Object
+             //     Options object as
+             //         id: String
+             //
+            options = options || {};
+
+            var dfd = new Deferred();
+            var id = options.id ? options.id : this.getIdentity(object);
+            var hasId = typeof id != "undefined";
+            xhr(hasId ? "PUT" : "POST", {
+                url: hasId ? this.target + id : this.target,
+                postData: json.toJson(object),
+                handleAs: "json",
+                headers:{
+                    "Content-Type": "application/json",
+                    Accept: this.accepts
+                }
+            }).then(lang.hitch(this,function(result){
+                if ( result.error ) {
+                    dfd.reject(result.reason);
+                } else {
+                    object[this.idProperty] = result[this._responseIdProperty];
+                    object[this.revProperty] = result[this._responseRevProperty];
+                    dfd.resolve(object);
+                }
+            }), function(err){
+                dfd.reject(getCouchError(err));
+            });
+            return dfd.promise;
+        },
+        add: function(object, options){
+            return this.put(object,options);
+        },
+        remove: function(id,rev){
+            var dfd = new Deferred();
+            xhr("DELETE",{
+                url: this.target + id,
+                headers: {
+                    'If-Match': rev
+                }
+            }).then(function(result){
+                if ( result.error ) {
+                    dfd.reject(result.reason);
+                } else {
+                    dfd.resolve();
+                }
+            },function(err){
+                dfd.reject(getCouchError(err));
+            });
+            return dfd.promise;
+        },
+        query: function(query, options){
+            // summary:
+            //    query a couchdb view
+            // query: String
+            //    name of a couchdb view you want to query, relative to the current database
+            // options: Object
+            //     options object as
+            //        start: Number
+            //            Start results at this item
+            //        count: Number
+            //            Number of items to return
+            //        sort: [{attribute:'key',descending:true|false}]
+            //            CouchDB only support sorting by key, so only 'key'
+            //            is allowed as attribute value. Multiple sort items
+            //            are ignored.
+            //        key: String|Array|Object
+            //            Return only values with this key.
+            //            Excludes start/endkey usage.
+            //        startkey: String|Array|Object
+            //            Return values starting from this key.
+            //        endkey: String|Array|Object
+            //            Return values with key lower than this key.
+            //        include_docs: true|false
+            //            Return the full documents instead of the view
+            //            values.
+            //        reduce: true|false
+            //            Execute reduce on the view or not. Default depends
+            //            on if a reduce function is defined on the view.
+            //        group: true|false
+            //            Should values be grouped per key or not? Default
+            //            is false.
+            //        group_level: Number
+            //            When group = true and the key is an array,
+            //            determines which elements starting from the first
+            //            are used for grouping. Default is 0.
+            //        get_keys: true|false
+            //            Instead of returning the values or documents,
+            //            return the array of keys as the result.
+            //            This does not affect the forPairs function.
+            options = options || {};
+
+            var dfd = new Deferred();
+            var queryOpts = {};
+            if ( !query ) {
+                query = '_all_docs';
+            }
+
+            if (!lang.isString(query)) {
+                console.warn("Query must be a view name");
+            }
+
+            // Standard options
+            if (options.start >= 0) {
+                queryOpts.skip = options.start;
+            }
+            if (options.count >= 0) {
+                queryOpts.limit = options.count;
+            }
+            if (options.sort) {
+                if (options.sort[0]) {
+                    if (options.sort[0].attribute && options.sort[0].attribute !== "key") {
+                        console.warn("Can only sort on key");
+                    }
+                    if (options.sort[0].descending) {
+                        queryOpts.descending = true;
+                    }
+                }
+                if (options.sort.length > 1) {
+                    console.warn("multiple sort fields not supported");
+                }
+            }
+
+            // Custom options
+            if (options.key !== undefined) {
+                queryOpts.key = options.key;
+            } else if (options.keys !== undefined) {
+                queryOpts.keys = options.keys;
+            } else if (options.startkey !== undefined || options.endkey !== undefined) {
+                queryOpts.startkey = options.startkey;
+                queryOpts.endkey = options.endkey;
+            }
+            if (options.include_docs !== undefined) {
+                queryOpts.include_docs = options.include_docs;
+            }
+            if (options.reduce !== undefined) {
+                queryOpts.reduce = options.reduce;
+            }
+            if (options.group !== undefined) {
+                queryOpts.group = options.group;
+                if (options.group_level !== undefined) {
+                    queryOpts.group_level = options.group_level;
+                }
+            }
+
+            for (var qp in queryOpts) {
+                queryOpts[qp] = json.toJson(queryOpts[qp]);
+            }
+            query += '?' + xhr.objectToQuery(queryOpts);
+
+            xhr("GET", {
+                url: this.target + query,
+                handleAs: "json",
+                headers: {
+                    Accept: this.accepts
+                }
+            }).then(function(result){
+                if (result.error) {
+                    dfd.reject(result.reason);
+                } else  {
+                    var results;
+                    var values = array.map(result.rows,function(result){
+                        return options.include_docs === true ? result.doc : result.value;
+                    });
+                    var keys = array.map(result.rows,function(result){
+                        return result.key;
+                    });
+                    if (options.get_keys === true) {
+                        results = keys;
+                        results.values = values;
+                    } else {
+                        results = values;
+                        results.keys = keys;
+                    }
+                    dfd.resolve(results);
+                }
+            },function(err){
+                dfd.reject(getCouchError(err));
+            });
+            return CouchResults(dfd.promise);
+        }
+    });
+
+    function CouchResults(results) {
+        results = QueryResults(results);
+        results.forPairs = function(callback,thisObject) {
+            callback = lang.hitch(thisObject,callback);
+            return Deferred.when(results,function(results) {
+                var values = results.values || results;
+                var keys = results.keys || results;
+                return array.forEach(values, function(value,index) {
+                    callback(value,keys[index],index);
+                });
+            });
+        };
+        return results;
+    }
+
+    return CouchStore;
+
+});
Index: Dev/branches/rest-dojo-ui/client/rft/store/ElasticReadStore.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/store/ElasticReadStore.js	(revision 410)
+++ Dev/branches/rest-dojo-ui/client/rft/store/ElasticReadStore.js	(revision 410)
@@ -0,0 +1,52 @@
+define([
+    'dojo/_base/declare',
+    "dojo/_base/json",
+    'dojo/_base/lang',
+    'dojo/_base/xhr',
+    'dojox/data/QueryReadStore'
+],function(declare, json, lang, xhr, QueryReadStore) {
+    return declare(QueryReadStore, {
+        fetch:function(request){
+            var attr = Object.keys(request.query)[0];
+            if (request.query[attr].length === 0) {
+                return 0;
+            }
+            var q = request.query[attr];
+
+            request.serverQuery = json.toJson({ 
+                query: {
+                    query_string: {
+                        default_field: attr, 
+                        query: q
+                    }
+                }
+            });
+            return this.inherited(arguments);
+          },
+        _fetchItems: function(request, fetchHandler, errorHandler){
+            var serverQuery = request.serverQuery;
+            var xhrHandler = xhr.post({
+                url: this.url,
+                handleAs: "json",
+                postData: serverQuery
+            }).then(lang.hitch(this, function(data){
+                this._xhrFetchHandler(data, request, fetchHandler, errorHandler);
+            }),function(error){
+                errorHandler(error, request);
+            });
+            request.abort = function(){
+                xhrHandler.cancel();
+            };
+        },
+        _xhrFetchHandler: function(data, request, fetchHandler, errorHandler) {
+            data = this._filterResponse(data);
+            this._items = [];
+            var numHits = data.hits.total || -1;
+            if(numHits > 0) {
+                this._items.push({i:data.hits.hits[0]._source, r:this, n:0});
+            }
+            fetchHandler(this._items, request, data.hits.total);
+            this._numRows = data.hits.total;
+        }
+    });
+});
Index: Dev/branches/rest-dojo-ui/client/rft/ui/Breadcrumbs.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/Breadcrumbs.js	(revision 409)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/Breadcrumbs.js	(revision 410)
@@ -6,6 +6,6 @@
     'dojo/topic',
     'dijit/_WidgetBase',
-    '../app/Controller'
-], function(declare, baseArray, Button, domClass, topic, _WidgetBase,Controller){
+    '../app/Router'
+], function(declare, baseArray, Button, domClass, topic, _WidgetBase,Router){
     return declare([_WidgetBase], {
         _crumbs: [],
@@ -61,5 +61,5 @@
                 iconClass: "dijitNoIcon",
                 onClick: lang.hitch(this, function(){
-                    Controller.go(path);  // TODO: fix this call!
+                    Router.go(path);  // TODO: fix this call!
                 })
             });
Index: Dev/branches/rest-dojo-ui/client/rft/ui/LoginDialog.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/LoginDialog.js	(revision 409)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/LoginDialog.js	(revision 410)
@@ -1,5 +1,5 @@
 define(['dojo/_base/declare','dojo/_base/lang','dojo/_base/event','dijit/Dialog',
     'dijit/_WidgetsInTemplateMixin','../auth', 'dojo/text!./templates/LoginDialog.html',
-    '../app/Controller','dijit/form/Form','dijit/form/Button','dijit/form/TextBox'],
+    '../app/Router','dijit/form/Form','dijit/form/Button','dijit/form/TextBox'],
     function (declare, lang, event, Dialog, _WidgetsInTemplateMixin, auth, template, content) {
         return declare([Dialog,_WidgetsInTemplateMixin], {
Index: Dev/branches/rest-dojo-ui/client/rft/ui/MenuBarLink.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/MenuBarLink.js	(revision 409)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/MenuBarLink.js	(revision 410)
@@ -1,4 +1,4 @@
-define(['dojo/_base/declare','dijit/MenuBarItem','../app/Controller'],
-function(declare,MenuBarItem,Controller){
+define(['dojo/_base/declare','dijit/MenuBarItem','../app/Router'],
+function(declare,MenuBarItem,Router){
     return declare([MenuBarItem],{
         options:{
@@ -6,5 +6,5 @@
         },
         onClick: function(){
-            this.path && Controller.go(this.path);
+            this.path && Router.go(this.path);
         }
     });
Index: Dev/branches/rest-dojo-ui/client/rft/ui/MenuLink.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/MenuLink.js	(revision 409)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/MenuLink.js	(revision 410)
@@ -1,4 +1,4 @@
-define(['dojo/_base/declare','dijit/MenuItem','../app/Controller'],
-function(declare,MenuItem,Controller){
+define(['dojo/_base/declare','dijit/MenuItem','../app/Router'],
+function(declare,MenuItem,Router){
     return declare([MenuItem],{
         options:{
@@ -6,5 +6,5 @@
         },
         onClick: function(){
-            this.path && Controller.go(this.path);
+            this.path && Router.go(this.path);
         }
     });
Index: Dev/branches/rest-dojo-ui/client/rft/ui/Notifications.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/Notifications.js	(revision 409)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/Notifications.js	(revision 410)
@@ -1,17 +1,7 @@
-define(['dojo/_base/declare','dojo/_base/lang','dojo/_base/connect','dojox/widget/Toaster'],
-    function(declare,lang,connect,Toaster){
-        return declare([Toaster],{
-            positionDirection: "br-up",
-            duration: 1000,
-            postCreate: function() {
-                this.inherited(arguments);
-                this.handle = connect.subscribe('/rft/notify',lang.hitch(this,function(notification){
-                    this.setContent(notification.text,notification.type || 'message');
-                }));
-            },
-            destroy: function() {
-                connect.unsubscribe(this.handle);
-                this.inherited(arguments);
-            }
-        });
+define(['dojo/_base/declare','dojo/_base/lang','dojox/widget/Toaster'],
+function(declare,lang,Toaster){
+    return declare([Toaster],{
+        positionDirection: "br-up",
+        duration: 1000
     });
+});
Index: Dev/branches/rest-dojo-ui/client/rft/ui/QuestionEditorToolkit.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/QuestionEditorToolkit.js	(revision 409)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/QuestionEditorToolkit.js	(revision 410)
@@ -129,5 +129,5 @@
             _setupCategories: function() {
                 this._categoryStore = new Memory({data: [] });
-                store.query("_design/default/_view/questions", {reduce:true, group:false, group_level:1})
+                store.query("_design/questions/_view/all", {reduce:true, group:false, group_level:1})
                 .forPairs(lang.hitch(this, function(value, key) {
                     this._categoryStore.put({ id: key[0] });
@@ -143,5 +143,5 @@
             _setupTopic: function(topic) {
                 this._topicStore = new Memory( {data: [] });
-                store.query("_design/default/_view/topics", {reduce:true, group:true})
+                store.query("_design/questions/_view/all_topics", {reduce:true, group:true})
                 .forPairs(lang.hitch(this, function(value, key) {
                     this._topicStore.put({ id: key });
Index: Dev/branches/rest-dojo-ui/client/rft/ui/Selector.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/Selector.js	(revision 409)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/Selector.js	(revision 410)
@@ -149,5 +149,5 @@
         },
 
-        addItem: function(item) {
+        addItem: function(item,displayTitle) {
             var actions = {};
             var action;
@@ -156,7 +156,5 @@
                     action = this.itemActions[actionName];
                     actions[actionName] = {
-                        callback: function(){
-                            action.callback && action.callback(item);
-                        },
+                        callback: action.callback && lang.partial(action.callback,item),
                         properties: {
                             blockButton: false,
@@ -165,9 +163,9 @@
                             tooltip: action.description
                         }
-                    }
+                    };
                 }
             }
             var w = new LineWithActionsWidget({
-                title: item.title,
+                title: displayTitle || item.title,
                 actions: actions
             }).placeAt(this.optionsNode);
Index: Dev/branches/rest-dojo-ui/client/rft/ui/TabbedQuestionBrowser.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/TabbedQuestionBrowser.js	(revision 409)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/TabbedQuestionBrowser.js	(revision 410)
@@ -9,111 +9,119 @@
     'rft/ui/Selector',
     'dojo/domReady!'
-    ],
-    function(declare,lang,win,ContentPane,TabContainer,Standby,store,Selector){
-        return declare([TabContainer],{
-            tabPosition: 'left-h',
+],function(declare,lang,win,ContentPane,TabContainer,Standby,store,Selector){
+    return declare([TabContainer],{
+        tabPosition: 'left-h',
+        include: 'all',
 
-            selectedActions: null,
-            itemActions: null,
+        selectedActions: null,
+        itemActions: null,
 
-            _dataMap: null,
-            _busyCount: 0,
-            constructor: function(){
-                this.inherited(arguments);
-                this._dataMap = {};
-            },
-            startup: function() {
-                if ( this._started ){ return; }
-                this.inherited(arguments);
-                this._busyWidget = new Standby({
-                    target: this.domNode,
-                    duration: 200
-                }).placeAt(win.body());
-                this._busyWidget.startup();
-                this.watch("selectedChildWidget",lang.hitch(this,function(name,oldTab,newTab){
-                    this._fillCategoryTab(newTab.__category);
+        _dataMap: null,
+        _busyCount: 0,
+        constructor: function(){
+            this.inherited(arguments);
+            this._dataMap = {};
+        },
+        postCreate: function() {
+            this.inherited(arguments);
+            this._query = '_design/questions/_view/'+this.include;
+        },
+        startup: function() {
+            if ( this._started ){ return; }
+            this.inherited(arguments);
+            this._busyWidget = new Standby({
+                target: this.domNode,
+                duration: 200
+            }).placeAt(win.body());
+            this._busyWidget.startup();
+            this.watch("selectedChildWidget",lang.hitch(this,function(name,oldTab,newTab){
+                this._fillCategoryTab(newTab.__category);
+            }));
+            store.query(this._query, {reduce:true,group:true,group_level:1})
+            .forPairs(lang.hitch(this,function(value,key){
+                this._createCategoryTab(key[0],value);
+            }));
+        },
+        _createCategoryTab: function(category,count) {
+            if (this._dataMap[category] === undefined) {
+                var categoryTab = new ContentPane({
+                    __category: category,
+                    title: (category || '[No category]')+" ("+count+")"
+                });
+                categoryTab.startup();
+                this._dataMap[category] = {
+                    _widget: categoryTab
+                };
+                this.addChild(categoryTab);
+            }
+        },
+        _fillCategoryTab: function(category) {
+            var categoryMap = this._dataMap[category];
+            if (!categoryMap._filled) {
+                this._busy();
+                categoryMap._filled = true;
+                store.query(this._query, {reduce:true,group:true,group_level:2,startkey:[category],endkey:[category,{}]})
+                .forPairs(lang.hitch(this,function(value,key){
+                    this._createTopicSelector(key[1],category,value);
+                })).then(lang.hitch(this,function(){
+                    this._done();
                 }));
-                store.query('_design/default/_view/questions', {reduce:true,group:true,group_level:1})
-                .forPairs(lang.hitch(this,function(value,key){
-                    this._createCategoryTab(key[0],value);
+            }
+        },
+        _createTopicSelector: function(topic,category,count){
+            var categoryMap = this._dataMap[category];
+            if (categoryMap[topic] === undefined) {
+                var w = new Selector({
+                    __category: category,
+                    __topic: topic,
+                    title: (topic || '[No topic]')+" ("+count+")",
+                    selectedActions: this.selectedActions,
+                    itemActions: this.itemActions
+                }).placeAt(categoryMap._widget.containerNode);
+                w.startup();
+                categoryMap[topic] = {
+                    _widget: w
+                };
+                this._fillTopicSelector(topic,category);
+            }
+        },
+        _fillTopicSelector: function(topic,category) {
+            var categoryMap = this._dataMap[category];
+            var topicMap = categoryMap[topic];
+            if (!topicMap._filled) {
+                topicMap._filled = true;
+                this._busy();
+                store.query(this._query, {reduce:false,include_docs:true,key:[category,topic]})
+                .forEach(lang.hitch(this,function(value){
+                    var title;
+                    if ( this.include === 'all' ) {
+                        title = value.title+(value.publicationDate?' (published on '+value.publicationDate+')':' (unpublished)');
+                    }
+                    topicMap._widget.addItem(value,title);
+                })).then(lang.hitch(this,function(){
+                    this._done();
                 }));
-            },
-            _createCategoryTab: function(category,count) {
-                if (this._dataMap[category] === undefined) {
-                    var categoryTab = new ContentPane({
-                        __category: category,
-                        title: (category || '[No category]')+" ("+count+")"
-                    });
-                    categoryTab.startup();
-                    this._dataMap[category] = {
-                        _widget: categoryTab
-                    };
-                    this.addChild(categoryTab);
+            }
+        },
+        _busy: function() {
+            if ( this._busyCount === 0 ) {
+                this._busyWidget.show();
+            }
+            this._busyCount++;
+        },
+        _done: function() {
+            if ( this._busyCount > 0 ) {
+                this._busyCount--;
+                if ( this._busyCount === 0 ) {
+                    this._busyWidget.hide();
                 }
-            },
-            _fillCategoryTab: function(category) {
-                var categoryMap = this._dataMap[category];
-                if (!categoryMap._filled) {
-                    this._busy();
-                    categoryMap._filled = true;
-                    store.query('_design/default/_view/questions', {reduce:true,group:true,group_level:2,startkey:[category],endkey:[category,{}]})
-                    .forPairs(lang.hitch(this,function(value,key){
-                        this._createTopicSelector(key[1],category,value);
-                    })).then(lang.hitch(this,function(){
-                        this._done();
-                    }));
-                }
-            },
-            _createTopicSelector: function(topic,category,count){
-                var categoryMap = this._dataMap[category];
-                if (categoryMap[topic] === undefined) {
-                    var w = new Selector({
-                        __category: category,
-                        __topic: topic,
-                        title: (topic || '[No topic]')+" ("+count+")",
-                        selectedActions: this.selectedActions,
-                        itemActions: this.itemActions
-                    }).placeAt(categoryMap._widget.containerNode);
-                    w.startup();
-                    categoryMap[topic] = {
-                        _widget: w
-                    };
-                    this._fillTopicSelector(topic,category);
-                }
-            },
-            _fillTopicSelector: function(topic,category) {
-                var categoryMap = this._dataMap[category];
-                var topicMap = categoryMap[topic];
-                if (!topicMap._filled) {
-                    topicMap._filled = true;
-                    this._busy();
-                    store.query('_design/default/_view/questions', {reduce:false,include_docs:true,key:[category,topic]})
-                    .forEach(lang.hitch(this,function(value){
-                        topicMap._widget.addItem(value);
-                    })).then(lang.hitch(this,function(){
-                        this._done();
-                    }));
-                }
-            },
-            _busy: function() {
-                if ( this._busyCount === 0 ) {
-                    this._busyWidget.show();
-                }
-                this._busyCount++;
-            },
-            _done: function() {
-                if ( this._busyCount > 0 ) {
-                    this._busyCount--;
-                    if ( this._busyCount === 0 ) {
-                        this._busyWidget.hide();
-                    }
-                } else {
-                    console.warn('_done() was called more times than _busy().');
-                }
-            },
-            destroy: function() {
-                this._busyWidget.destroyRecursive();
-                this.inherited(arguments);
+            } else {
+                console.warn('_done() was called more times than _busy().');
             }
-        });
+        },
+        destroy: function() {
+            this._busyWidget.destroyRecursive();
+            this.inherited(arguments);
+        }
     });
+});
Index: Dev/branches/rest-dojo-ui/client/rft/ui/ThresholdFilteringSelect.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/ui/ThresholdFilteringSelect.js	(revision 410)
+++ Dev/branches/rest-dojo-ui/client/rft/ui/ThresholdFilteringSelect.js	(revision 410)
@@ -0,0 +1,18 @@
+define([
+    'dojo/_base/declare',
+    'dijit/form/FilteringSelect'
+], function(declare, FilteringSelect) {
+    return declare(FilteringSelect, {
+         // custom min input character count to trigger search
+         minKeyCount: 3,
+
+         // override search method, count the input length
+         _startSearch: function (/*String*/key) {
+             if (!key || key.length < this.minKeyCount) {
+                 this.closeDropDown();
+                 return;
+             }
+             this.inherited(arguments);
+         }
+    });
+});
Index: Dev/branches/rest-dojo-ui/client/rft/view.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/view.js	(revision 409)
+++ Dev/branches/rest-dojo-ui/client/rft/view.js	(revision 410)
@@ -1,11 +1,29 @@
 require([
+    'dojo/hash',
     'dojo/parser',
-    'rft/stddeps',
-    'dojo/domReady!'
-],function(parser) {
+    'rft/app/Content',
+    'rft/app/Page',
+    'rft/pages/viewSurvey',
+    'dojo/domReady!',
+    'rft/stddeps'
+],function(hash,parser,Content,Page,viewSurvey) {
     parser.parse();
+    Content.startup();
+
+    var match = /^!\/(\w+)$/g.exec(hash());
+    if ( !match ) {
+        Content.set(new Page({
+            templateString: "<div>Something is wrong with the URL, don't know what survey to show you. Sorry.</div>"
+        }));
+        return;
+    }
+    var surveyId = match[1];
+
     // read options from hash/url
+    // 
     // authenticate
-    // set content
-    // go for it
+
+    Content.set(new viewSurvey({
+        surveyId: surveyId
+    }));
 });
